
-- VHDL Test Bench Created from source file LEDTutorial.vhd -- Thu Aug 08 14:58:32 2013

--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Lattice recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "source->import"
-- menu in the ispLEVER Project Navigator to import the testbench.
-- Then edit the user defined section below, adding code to generate the 
-- stimulus for your design.
-- 3) VHDL simulations will produce errors if there are Lattice FPGA library 
-- elements in your design that require the instantiation of GSR, PUR, and
-- TSALL and they are not present in the testbench. For more information see
-- the How To section of online help.  
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT LEDTutorial
	PORT(
		rstn : IN std_logic;
		clk_25mhz : IN std_logic;
		ld_button : IN std_logic;
		sr_button : IN std_logic;
		sl_button : IN std_logic;          
		led_out : OUT std_logic_vector(3 downto 0)
		);
	END COMPONENT;

	SIGNAL rstn :  std_logic := '1';
	SIGNAL clk_25mhz :  std_logic := '1';
	SIGNAL ld_button :  std_logic := '1';
	SIGNAL sr_button :  std_logic := '1';
	SIGNAL sl_button :  std_logic := '1';
	SIGNAL led_out :  std_logic_vector(3 downto 0);

BEGIN
	
	---------------------------------------------------
	-- clock generator, period 40 ns, half period 20 ns
	---------------------------------------------------
	clk_25mhz <= not clk_25mhz after 20 ns;
	---------------------------------------------------
	-- clock generator, period 40 ns, half period 20 ns
	---------------------------------------------------

-- Please check and add your generic clause manually
	uut: LEDTutorial PORT MAP(
		rstn => rstn,
		clk_25mhz => clk_25mhz,
		ld_button => ld_button,
		sr_button => sr_button,
		sl_button => sl_button,
		led_out => led_out
	);


-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
		rstn      <= '1';
		ld_button <= '1';
		sr_button <= '1';
		sl_button <= '1';
		wait for 100 ns;
		-- rstn active pulse
		rstn <= '0';
		wait for 200 ns;
		rstn <= '1';
		--
		wait for 500 ns;
		--
		ld_button <= '0';
		--
		wait for 500 ns;
		--
		ld_button <= '1';
		--
		wait for 500 ns;
		--
		sr_button <= '0';
		--
		wait for 2 us;
		--
		sr_button <= '1';
		--
		wait for 500 ns;
		--
		sl_button <= '0';
		--
		wait for 2 us;
		--
		sl_button <= '1';
		--
		wait for 500 ns;
		--
      wait; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
